#!/usr/bin/perl

##############################################################################
## this script delete data from satellites in eclipse mode.					##
## for predict orbits delete all the data until a new prediction is done	##
## reads form the standard input and outputs the data in the same format	##
## unhealthy satellites are also deleted									##
##############################################################################	

$,=" ";
$\="\n";
$[=1;
$|=1;

open(F2,"> del_eclipse.log");

open (F1,"eclipse.dat") ;
while(<F1>) {
chop;
@d=split(" ",$_,8);
$n_ec_periods{$d[2]}++;
$i=$n_ec_periods{$d[2]};
$first_epoch{$d[2]." ".$i}=$d[3];
$last_epoch{$d[2]." ".$i}=$d[4];
            }

open (F1,"axis.dat");

while(<F1>) {
chop;
@d=split(" ",$_,8);
if ($d[5]*1!=0) {$bad_sat{$d[2]}=1};
            }

$ndata=0;
while(<>) {
chop;
@d=split(" ",$_,18);
if ($ndata==0) {$doy0=$d[2]}
$t=($d[2]-$doy0)*86400+$d[3];
$n=$n_ec_periods{$d[6]};

$eclipse_mode=0;
for $i (1..$n) {
$tl=$last_epoch{$d[6]." ".$i};

$tf=$first_epoch{$d[6]." ".$i};

if (($t<$tf && ($tf-$t)<=301) || ($t>=$tf && $t<=$tl)) {
$eclipse_mode=2;
$t_f=$tf;$t_l=$tl;
                                                       }

               }
if ($eclipse_mode==0 && $bad_sat{$d[6]}*1==0) {
print $_;
                                              } else {

if (length($d[5])==3 && $eclipse_mode==2 && $bad_sat{$d[6]}*1==0) {
$d[12]=-1*$d[12];
printf "%2d %3d %6d %4s %4s  %2d %16.4f %16.4f %14.4f %14.4f %3d %4d %4d %5d %1d\n",@d;
                                                                   }
if (length($d[5])==4 && $eclipse_mode==2 && $bad_sat{$d[6]}*1==0) {
$d[14]=-1*$d[14];
printf "%2d %3d %6d %4s %4s  %2d %16.4f %16.4f %16.4f %14.4f %14.4f %14.4f %3d %4d %4d %4d %5d %1d %1d \n",@d;
                                                                  }

print (F2 $t,$d[6],$t_f,$t_l)
                 
                             }
$ndata++;
          }
