#!/usr/bin/perl

#####################################################
## Reads the antenna phase center of the receiver	#
#####################################################

$,=" ";
$[=1;
$\="\n";
$|=1;

$sta=$ARGV[1];

$atx_file="../info_files/current_file.atx";

$g2r=atan2(1,1)/45;

open(F1,"sta.coor");

while(<F1>) {
chop;
@d=split(' ',$_,9);
if (lc($d[1]) eq lc($sta)) {
             $antenna=substr($_,70,16);
             $element=substr($_,86,4);
             $xlat=$d[4]*$g2r;
             $xlon=$d[3]*$g2r;
             $height=$d[6];
                            }
              

           }

open (F10,">> antenna.log");

$antenna_found=0;
antenna_label:

open (F1,$atx_file);


while(<F1>) {
chop;
@d=split(' ',$_,29);
if (substr($_,61,11) eq "TYPE / SERI") {
$flag=0;
if (substr($_,1,16) eq $antenna) {
if (substr($_,1,16) eq $antenna && substr($_,17,4) eq $element) {
$flag=1;
$nfreq=0;
$antenna_found=1;
                                                                }
                                   }
                                        }

if (substr($_,61,11) eq "START OF FR") {$fr_ty=substr($d[1],3,1)*1}
if ($flag==1 && substr($_,61,11) eq "NORTH / EAS") {
$nfreq++;
print (F10 $antenna,$fr_ty,@d);
$freq_type[$nfreq]=$fr_ty;
$d[1]=-1*$d[1];
$d[3]=$d[3]+$height*1000;
@b=rot(3,-1*$xlon,rot(2,-(90.*$g2r-$xlat),@d[1..3]));
for $i (1..3) {$antenna_tie{$nfreq." ".$i}=$b[$i]*0.001}
                                                   }

if ($flag==1 && substr($_,61,11) eq "ZEN1 / ZEN2") {
@zentics = @d[1..3]
                                                    }
if ($flag==1 && $d[1] eq "NOAZI") {
for $i (1..$#d-1) {$ant_cal{$nfreq." ".$i}=0.001*$d[eval($i+1)]};
                                  }


             }

if ($antenna_found==0) {
     print (F10 $sta,"NO ANTENNA+ELEMENT FOUND TRYING ELEMENT NONE");
      if ($element ne "NONE") {
     $element="NONE";
     goto antenna_label;
                              }
                       }

if ($antenna_found==0) {
print (F10 "WARNING NO ANTENNA FOUND FOR ",$sta,$antenna)
                       }

open (F2,"> antenna.dat");
if ($antenna_found!=0) {
$zenit_levels=int(($zentics[2]-$zentics[1])/$zentics[3]+0.5)+1;
for $i (1..$nfreq) {
printf (F2 "%1d ",$freq_type[$i]);
for $j (1..3) {printf (F2 "%8.4f",$antenna_tie{$i." ".$j})}
for $j (1..3) {printf (F2 "%5.1f ",$zentics[$j])}
for $j (1..$zenit_levels) {printf (F2 "%7.4f ",$ant_cal{$i." ".$j})}
printf (F2 "\n");
                   } } else {

printf (F2 "%1d %8.4f %8.4f %8.4f %5.1f %5.1f %5.1f %7.4f\n",1,0,0,0,0,80,80,0); 
printf (F2 "%1d %8.4f %8.4f %8.4f %5.1f %5.1f %5.1f %7.4f\n",2,0,0,0,0,80,80,0);


                            }

sub rot {
my @d = @_;
if ($d[1]==1) {
$r[1]=$d[3];
$r[2]=$d[4]*cos($d[2])+$d[5]*sin($d[2]);
$r[3]=-1*$d[4]*sin($d[2])+$d[5]*cos($d[2]);
return @r;
              }
if ($d[1]==2) {
$r[1]=$d[3]*cos($d[2])-$d[5]*sin($d[2]);
$r[2]=$d[4];
$r[3]=$d[3]*sin($d[2])+$d[5]*cos($d[2]);
return @r;
              }
if ($d[1]==3) {
$r[1]=$d[3]*cos($d[2])+$d[4]*sin($d[2]);
$r[2]=-$d[3]*sin($d[2])+$d[4]*cos($d[2]);
$r[3]=$d[5];
return @r;
              }
         }
