#!/usr/bin/perl

$,=" ";
$[=1;
$\="\n";
$|=1;

#########################################################
## This program converts the standard product sp3 file  #
## (containing precise orbits into a tab file			#
#########################################################

##################CONSTANTS
$c_light=299792458;


###########################

while (<>) {
chop;
@d=split(' ',$_,20);

if ($ndata==0) {$mode = substr(3,1)}

if ($d[1] eq "*") {
    cal2doy(@d[2..7]);       
if ($n_epochs==0) {printf "HEADER: %02d %3d %2d \n",$year,$doy,$d[5];$doy0=$doy}
$n_epochs++;
                  }
if (substr($_,1,1) eq "P") {
  $gnss_type=substr($_,2,1);$sat=substr($_,3,2)*1;
  if ($gnss_type eq " ") {$gnss_type="G"};
  $x=substr($_,5,14)*1;$y=substr($_,19,14)*1;
  $z=substr($_,33,14)*1;$clock=substr($_,47,14)*$c_light*1e-9;
       if ($mode ne "V") {
if ($x**2+$y**2+$z**2 > 1e6 && $clock**2<1e10) {
  printf "%6d %1s %2d %14.6f %14.6f %14.6f %14.9f %14.9f %14.9f %14.6f\n",($doy-$doy0)*86400+$sec,$gnss_type,$sat,$x,$y,$z,0,0,0,$clock;
                                                  }
                         }
                           }
if (substr($_,1,1) eq "V") {
$vx=substr($_,5,14)*1.e-4;$vy=substr($_,19,14)*1.e-4;
$vz=substr($_,33,14)*1.e-4;
if ($x**2+$y**2+$z**2 > 1e6 && $clock**2<1e10) {
  printf "%6d %1s %2d %14.6f %14.6f %14.6f %14.9f %14.9f %14.9f %14.6f\n",($doy-$doy0)*86400+$sec,$gnss_type,$sat,$x,$y,$z,$vx,$vy,$vz,$clock;
                                                  }
                           }

$ndata++;
           } 


################################### Sub CAL2DOY
## transform "year month day hour min sec" into "yy day_of_year sec_of_day"
######################################
sub cal2doy {
local (@xy) = @_;
my @month_days0=(31,28,31,30,31,30,31,31,30,31,30,31);
$year=$xy[1]%100;$month=$xy[2];$day=$xy[3];$hour=$xy[4];$min=$xy[5];
$sec=$xy[6];
$doy=0;
@month_days=@month_days0;


#### remember that year 2000 had also 366 days, this must be corrected by the
#### XXII century.
if ($year%4==0) {$month_days[2]=29}
for ($i=1;$i<=$month-1;$i++){$doy=$doy+$month_days[$i]}
$doy=$doy+$day;
$sec=int($sec+0.3)+$hour*3600+$min*60;
            }

