c234567

c This program detects cycle slips

      implicit double precision (a-h,o-z)
      parameter (LVAR=20,IRD=100,NS=40,NST=120)
        dimension t0(NST,NS,LVAR),xion(NST,NS,LVAR),n_sat(NST,NS),
     * narc(NST,NS),a(IRD,IRD),y(IRD),va(IRD*IRD),aty(IRD),x(IRD),
     * ncyc1(NST,NS),xcyc1(NST,NS),xw(NST,NS),sw(NST,NS),
     * si(NST,NS),ssi(NST,NS),narc0(NST,NS),xcyc2(NST,NS),
     * ncyc2(NST,NS),iwait_cycle(NST,NS),xw_50(NST,NS),f_(10),
     * ifreq(4),ndata_sat(NST,NS),f_sat(NST,NS,2)

         character*4 sta_name(NST),sta,aa
         character*3 a3
         character*1 aa1,gnss_type

         call getarg(1,aa)
         read (aa,*) dt
 
         r2g=datan2(1.d0,1.d0)/45.d0
         f0=10.23d6
         f1=154*f0
         f2=120*f0
         c=299792458

             f_(1)=1575.42d6
             f_(2)=1227.60d6
             f_(3)=0000.00d0
             f_(4)=0000.00d0
             f_(5)=1176.45d6
             f_(6)=1278.75d6
             f_(7)=1207.14d6
             f_(8)=1191.795d6



         
         ndeg=2
         npoints=ndeg+6
         n_sta=0

         idata=0

         if (dt .lt. -10) then
          ndeg=1
          npoints=ndeg+3
         endif


         do j=1,NST
         do i=1,NS
          iwait_cycle(j,i)=0
          narc(j,i)=0
          n_sat(j,i)=0
          do k=1,LVAR
           t0(j,i,k)=0.d0
           xion(j,i,k)=0.d0
          enddo
          ndata_sat(j,i)=0
          xw(j,i)=0.d0
          sw(j,i)=0.2
          ssi(j,i)=1.
         enddo
         enddo
         i=0

          open (unit=20,file='cycle.log')

10       read (*,*,end=11) iy,iday,itime,sta,a3,isat,xl1,xl2,
     * xp1,xp2,iar,is1,is2,ignss_week,ignss_day


ccccccccccccccccccccccccccccccccccc

         read (a3(1:1),'(a1)') aa1
         read (aa1,*) gnss_type

          do i=1,n_sta
           if (sta_name(i) .eq. sta) then
            ista=i
            goto 511
           endif
          enddo

          n_sta=n_sta+1
          sta_name(n_sta)=sta
          ista=n_sta
511      continue

         iss=isat

         if (gnss_type .eq. "E") iss=iss+40       

        if (ndata_sat(ista,iss) .eq. 0) then
        do k=2,3
         read (a3(k:k),'(a1)') aa1
         read (aa1,*) ifreq(k-1)
        enddo

        f_sat(ista,iss,1)=f_(ifreq(1))
        f_sat(ista,iss,2)=f_(ifreq(2))

        write (20,*) "frecuencias:  ",gnss_type," ",sta_name(ista),
     * isat,iss,f_sat(ista,iss,1),f_sat(ista,iss,2)
         ndata_sat(ista,iss)=1
        endif

        f1=f_sat(ista,iss,1)
        f2=f_sat(ista,iss,2)

cccccccccccccccccccccccccccccccccc

       ttime=dfloat(itime)
       xpi=xp2-xp1
       xi=xl1-xl2
       xlw=(f1*xl1-f2*xl2)/(f1-f2)
       xpw=(f1*xp1+f2*xp2)/(f1+f2)

         if (idata .eq. 0)  iday0=iday 

          idata=idata+1

          time=dfloat(iday-iday0)*86400.+ttime

          if (sta .eq. 'gpsm' .or. sta .eq. 'cham')  then 
           dxmax=1.d2
           dmax_xi=8.0d-2
          x1_times=2.d0
          s_wide=1.
          wide_times=5.
          else
           dxmax=1.d0
           dmax_xi=0.08*1.d0/(1.d0+exp(-dt/30.))
           x1_times=2.d0
           s_wide=0.8
           wide_times=5.

c          STORM mode
c          dmax_xi=0.01*1.d1/(1.d0+exp(-dt/60.))
c          x1_times=5.d1
c          s_wide=0.2
          endif


          if (xpi**2 .gt. 1.d6) goto 10
          if (dabs(time-t0(ista,isat,2)) .lt. 1.d-5 
     *   .and. n_sat(ista,isat) .gt. 0. ) goto 10




           if ((time-t0(ista,isat,1) .gt. dt+1.d-5 .and.
     *  n_sat(ista,isat) .gt. 0) .or. (dabs(xi-xion(ista,isat,1)) 
     *  .gt. dxmax .and. n_sat(ista,isat) .gt. 0) .or.  
     *   narc0(ista,isat) .ne. iar  ) then
            n_sat(ista,isat)=0
            narc(ista,isat)=narc(ista,isat)+1
            narc0(ista,isat)=iar
           write (20,*) time,sta_name(ista),isat,'* ',
     * time-t0(ista,isat,1),n_sat(ista,isat),
     * dabs(xi-xion(ista,isat,1)),dxmax,narc0(ista,isat),iar
           endif

           if (n_sat(ista,isat) .lt. npoints-1) then
           xcyc1(ista,isat)=xl1-xp1
           xcyc2(ista,isat)=xl2-xp2
           else
           ncyc1(ista,isat)=nint(xcyc1(ista,isat)/(c/f1))
           ncyc2(ista,isat)=nint(xcyc2(ista,isat)/(c/f2))
           endif

          n_sat(ista,isat)=n_sat(ista,isat)+1
           i= n_sat(ista,isat)
          t0(ista,isat,1)=time
           xion(ista,isat,1)=xi



          if (n_sat(ista,isat) .ge. npoints) then


               do j=2,npoints
                y(j)=xion(ista,isat,j)-xion(ista,isat,2)
               do k=0,ndeg
                a(j,k+1)=(t0(ista,isat,j)-t0(ista,isat,2))**k
               enddo
               enddo

             do k=1,ndeg+1
             do j=1,k
             va(k*(k-1)/2+j)=0.d0 
             enddo
             aty(k)=0.d0
             enddo

            if (iwait_cycle(ista,isat) .eq. 1) then
             istart=2
             else
              istart=1
             endif

            do k=1,ndeg+1
             do j=1,k
                do l=istart,npoints-1
             va(k*(k-1)/2+j)=va(k*(k-1)/2+j)+a(l,j)*a(l,k)
                enddo
             enddo
                do l=istart,npoints-1
             aty(k)=aty(k)+a(l,k)*y(l)
                enddo
            enddo


            call dpptrf('U',ndeg+1,va,ier1)
            call dpptri('U',ndeg+1,va,ier2)

            call dspmv('U',ndeg+1,1.d0,va,aty,1,0.d0,x,1)

            x0=0.d0
            do j=1,ndeg+1
             x0=x0+x(j)*(t0(ista,isat,1)
     *       -t0(ista,isat,2))**(j-1)
            enddo




       if ( 
     *                     (
     * dabs(xion(ista,isat,1)-x0-xion(ista,isat,2)) 
     * .gt. dmax_xi .and.
     * dabs(xion(ista,isat,1)-x0-xion(ista,isat,2)) .gt. 
     *                               dabs(x1_times*x(1))
     *                      ) .or.
     *                      (
     * dabs(xlw-xpw-xw(ista,isat)) .gt. wide_times*s_wide .or.
     * (dabs(xlw-xpw-xw_50(ista,isat)) .gt. s_wide .and.
     * n_sat(ista,isat) .gt. 50 .and.
     * dabs(xw_50(ista,isat)-xw(ista,isat)) .lt. 0.25*s_wide) .or.
     * (dabs(xlw-xpw-xw(ista,isat)) .gt. 
     * wide_times*dsqrt(sw(ista,isat)) 
     * .and. dsqrt(sw(ista,isat)) .lt. s_wide) 
     *                      )
     *    ) then


                      if (iwait_cycle(ista,isat) .eq. 1) then

           write (20,*) time,sta_name(isat),isat,'** confirmed','** ',
     * dabs(xion(ista,isat,1)-x0-xion(ista,isat,2)),
     * xion(ista,isat,1)-xion(ista,isat,2),
     * ' dmax_xi= ',dmax_xi,
     * ' x1_times*x(1)= ',x1_times*x(1),x0+xion(ista,isat,2),
     * " W ",dabs(xlw-xpw-xw(ista,isat)),dabs(xlw-xpw-xw_50(ista,isat)),
     * ' sw= ',wide_times,sw(ista,isat),' s_wide= ',s_wide,
     * xion(ista,isat,1),iwait_cycle(ista,isat),ier1,ier2,
     * (nint(t0(ista,isat,j)),j=1,5)




            i=0
            t0(ista,isat,1)=time
            n_sat(ista,isat)=0
             xcyc1(ista,isat)=0.d0
             xcyc2(ista,isat)=0.d0
            narc(ista,isat)=narc(ista,isat)+1
             sw(ista,isat)=0.2
             xw(ista,isat)=xlw-xpw
             si(ista,isat)=xpi-xi

             iwait_cycle(ista,isat)=0
                       else

           write (20,*) time,isat,'** ',
     * dabs(xion(ista,isat,1)-x0-xion(ista,isat,2)),
     * xion(ista,isat,1)-xion(ista,isat,2),
     * ' dmax_xi= ',dmax_xi,
     * ' x1_times*x(1)= ',x1_times*x(1),x0+xion(ista,isat,2),
     * dabs(xlw-xpw-xw(ista,isat)),dabs(xlw-xpw-xw_50(ista,isat)),
     * ' sw= ',wide_times,sw(ista,isat),' s_wide= ',s_wide,
     * xion(ista,isat,1),iwait_cycle(ista,isat),ier1,ier2,
     * (nint(t0(ista,isat,j)),j=1,5)

           iwait_cycle(ista,isat)=1

ccccc  if (iwait_cycle(ista,isat) .eq. 1) 
                     endif

            else

                   if (iwait_cycle(ista,isat) .eq. 1) then
          write (20,*) time,sta_name(ista),isat,' not confirmed ',
     * dabs(xion(ista,isat,1)-x0-xion(ista,isat,2)),
     * xion(ista,isat,1)-xion(ista,isat,2),
     * ' dmax_xi= ',dmax_xi,
     * ' x1_times*x(1)= ',x1_times*x(1),x0+xion(ista,isat,2),
     * dabs(xlw-xpw-xw(ista,isat)),dabs(xlw-xpw-xw_50(ista,isat)),
     *' sw= ',wide_times,sw(ista,isat),' s_wide= ',s_wide,
     * xion(ista,isat,1),iwait_cycle(ista,isat),ier1,ier2,
     * (nint(t0(ista,isat,j)),j=1,5)



                     endif

       write (*,'(i2,1x,i3,i7,1x,a4,1x,a3,1x,i2,4(1x,f14.4),
     *  1x,i4,2(1x,i3),1x,i8,1x,i1)'),
     * iy,iday,itime,sta_name(ista),a3,isat,
     * xl1-ncyc1(ista,isat)*c/f1,
     * xl2-ncyc2(ista,isat)*c/f2,xp1,xp2,narc(ista,isat)+1,
     * is1,is2,ignss_week,ignss_day

       call f77flush()



          iwait_cycle(ista,isat)=0

ccc      if (
           endif

cccc          if (n_sat(ista,isat) .ge. npoints) then
          endif


c         print *,'AAA',time,isat,xw(isat),2*dsqrt(sw(isat)),
c    *  xlw-xpw-xw(isat),narc(isat),n_sat(isat)

           if (((dabs(xlw-xpw-xw(ista,isat)) .gt. 10.*s_wide .and.
     *   sw(ista,isat) .lt. s_wide) .or. dabs(xlw-xpw-xw(ista,isat)) 
     *   .gt. 20.*s_wide) .and.
     *   n_sat(ista,isat) .gt. 2) then
            i=0
            t0(ista,isat,1)=time
            n_sat(ista,isat)=0
             xcyc1(ista,isat)=0.d0
             xcyc2(ista,isat)=0.d0
            narc(ista,isat)=narc(ista,isat)+1
             sw(ista,isat)=0.2
             xw(ista,isat)=xlw-xpw
             si(ista,isat)=xpi-xi
           endif 

          if (n_sat(ista,isat) .gt. 0) then
            b00=xw(ista,isat)
           if (n_sat(ista,isat) .eq. 1)  b00=xlw-xpw

           b01=si(ista,isat)


           si(ista,isat)=si(ista,isat)+(xpi-xi-si(ista,isat))/
     *       n_sat(ista,isat)
           ssi(ista,isat)=ssi(ista,isat)+((xpi-xi-b01)**2
     *     -ssi(ista,isat))/n_sat(ista,isat)


          if (iwait_cycle(ista,isat) .ne. 1) then
           xw(ista,isat)=xw(ista,isat)+(xlw-xpw-xw(ista,isat))
     *      /n_sat(ista,isat)
         sw(ista,isat)=sw(ista,isat)+((xlw-xpw-b00)**2-sw(ista,isat))
     *     /n_sat(ista,isat)
         if (n_sat(ista,isat) .lt. 50) then
           xw_50(ista,isat)=xw(ista,isat)
         else
           xw_50(ista,isat)=(9.*xw_50(ista,isat)+(xlw-xpw))/10.
         endif
          endif
          if (n_sat(ista,isat) .lt. 3) ssi(ista,isat)=1.
          endif


           do j=npoints,2,-1
            t0(ista,isat,j)=t0(ista,isat,j-1)
            xion(ista,isat,j)=xion(ista,isat,j-1)
           enddo


          goto 10
11        continue
          end
