#!/usr/bin/perl

######################################################################################
# Computes and detects the medium scale TIDs amplitud. It reads from STDIN with the	##
# format of cherck_arcs.pl program output. It writes in a file mstid.yy.doy			##
######################################################################################


$,=" ";
$\="\n";
$|=1;
$[=1; #arrays begin at 1


#year and day from command line to label output file
$yy = $ARGV[1];
$doy = $ARGV[2];

#declare variables
$d_t=30;
$dt_output=300;
$dt_acum=600;
$max_idx=$dt_acum/$d_t;

open (F2,">> mstid_idx.$yy.$doy"); #open the file for store the data (appends)
while (<STDIN>) {
chop;
select (STDOUT);
#print $_;
#Stores line by line standard input
@d=split(' ',$_,22);
$sta=$d[2];
$idx{$sta}=($d[1]/$d_t)%($dt_acum/$d_t)+1;
$lab{$sta}=$d[3]." ".$d[4];
$d2stec{$lab{$sta}." ".$idx{$sta}}=$d[6]-0*$d2stec{$lab{$sta}." ".$idx{$sta}};
$idx_time{$lab{$sta}." ".$idx{$sta}}=$d[1];
$e_d2stec{$lab{$sta}." ".$d[1]}=1;

if ($d[1]%$dt_output==0) {
$mstid_idx=0;
$n_idx=0;
$flag=0;
for $i (1..$max_idx) {
    $t0=$idx_time{$lab{$sta}." ".$i};
    if ($e_d2stec{$lab{$sta}." ".$t0}==1) {
                $n_idx++;
            $mstid_idx+=$d2stec{$lab{$sta}." ".$i}**2;
            if (abs($d2stec{$lab{$sta}." ".$i})>0.15) {$flag=1}
                               }
                      }
    if ($n_idx<$max_idx) {$flag+=1}
    if ($n_idx>=$max_idx-3) {
        select (F2);

if(($d[1]-86400)>=0 && ($d[1]-86400)<=86400){
printf ("%6d %4s %3d %4d %10.7f %7.2f %7.2f %9.6f %9.6f %9.6f %4.1f %1i \n",$d[1]-86400,$d[2],$d[3],$d[4],sqrt($mstid_idx/$n_idx),@d[10..14],sqrt($d[9]),$flag);
    }
        $|++;
                        }

                     }



}
