#!/usr/bin/perl

##############################################################
## Downloads rapid and ultra-rapid clock and orbit data		##
##############################################################


$,=" ";
$[=1;
$\="\n";
$|=1;

open (F10,"> time_handle.log");
$ndata_t=();
while(<>) {
chop;
@d=split(' ',$_,25);

if ($ndata==0) {
$year=2000+$d[1];
$day0=$d[2];
if ($day0<100) {$day0="0".$day0};
if ($day0<10) {$day0="0".$day0};
$gps_week=$d[$#d-1];
$gps_day=$d[$#d];
$brd_file = $year."/".$day0."/".$d[1]."n/brdc".$day0."0.".$d[1]."n.Z";
`wget ftp://cddis.gsfc.nasa.gov/pub/gps/data/daily/$brd_file`;
$brd_file = "brdc".$day0."0.".$d[1]."n.Z";
`zcat $brd_file |../prefits_bin/brdc2axis.pl > axis.dat`;

if ($d[3]>14400) {  
$hour0=int(($d[3]-14400)/21600+0.5)*6;
$hour0=18;

if ($hour0 < 10) {$hour0="0".$hour0}
##$igu_file=$gps_week."/igu".$gps_week.$gps_day."_".$hour0.".sp3.Z";
$igu_file=$gps_week."/igu".$gps_week.$gps_day."_".$hour0.".sp3.Z";
`wget ftp://cddis.gsfc.nasa.gov/pub/gps/products/$igu_file`;
##$igu_file="igu".$gps_week.$gps_day."_".$hour0.".sp3.Z";;
$igu_file="igu".$gps_week.$gps_day."_".$hour0.".sp3.Z";
`zcat $igu_file | ../prefits_bin/sp32txt.pl |../prefits_bin/add_brdc_clock_2_igu.pl $d[$#d] $d[2]  > orbit_gnss.dat`;
#`../prefits_bin/merge_orbits_files $d[2] $d[3]`;
open (F6,"> orbit.tmp");
open (F5,"orbit_gnss.dat");
while(<F5>) {
chop;
@q=split(' ',$_,12);
if ($q[1] eq "HEADER:") {$dayq=$q[3]} else {
if ($q[1] < 2*86400+12000) {print (F6 $dayq,$_)}
                                           }
            }
close (F6);
print (F10 "A ",$time,$igu_file);

                 } else {
if ($gps_day==0) {
$h_day=6;
$h_week=-1;
                 } else {$h_day=-1}
$igu_file=$gps_week."/igu".eval($gps_week).eval($gps_day)."_18.sp3.Z";
`wget ftp://cddis.gsfc.nasa.gov/pub/gps/products/$igu_file`;
$igu_file="igu".eval($gps_week).eval($gps_day)."_18.sp3.Z";;
`zcat $igu_file | ../prefits_bin/sp32txt.pl| ../prefits_bin/add_brdc_clock_2_igu.pl $d[$#d] $d[2] > orbit_gnss.dat`;
print (F10 "B ",$time,$igu_file);
                        }

`../prefits_bin/detect_eclipse`;
open(F2,"|../prefits_bin/del_eclipse_data.pl|../prefits_bin/model|");

##### if ($ndata==0)
               }
$ndata=1;
$time=($d[2]-$day0)*86400+$d[3];
$ndata_t{$time}++;



if ($time%21600==12000 && $ndata_t{$time}==1 && $time>=86400) {
$doy=$d[2];
if ($doy<100) {$doy="0".$doy*1}
if ($doy<10) {$doy="0".$doy}

##############    BRDC #####################
$brd_file = $year."/".$doy."/".$d[1]."n/brdc".$doy."0.".$d[1]."n.Z";

##print "BRD_FILE ",$brd_file,$doy;
`wget ftp://cddis.gsfc.nasa.gov/pub/gps/data/daily/$brd_file`;
$brd_file = "brdc".$doy."0.".$d[1]."n.Z";
if (1*$d[2]==1*$day0) {
`zcat $brd_file |../prefits_bin/brdc2axis.pl > axis1.tmp`;
                  } else {
`zcat $brd_file |../prefits_bin/brdc2axis.pl > axis.tmp`;
open (F3,"axis.tmp");
open (F4,"> axis2.tmp");
while (<F3>) {
chop;
@g=split(' ',$_,8);
$g[1]=$g[1]+86400;
print (F4 @g);
             }
close (F4);
`cat axis1.tmp axis2.tmp > axis.dat`;
                 }
#################################################

###### cambio temporal ######

##if ($time>=100800)  {
##if ($time>=90500)  {
#if ($time>=64800)  {
$gps_week=$d[$#d-1];
$gps_day=$d[$#d];
$hour0=int(($d[3]-12000)/21600+0.3)*6;
if ($hour0 < 10) {$hour0="0".$hour0}


if ($d[3] > 188000) {
$igu_file = $gps_week."/igr".$gps_week.$gps_day.".sp3.Z";
                   }
else
                   {
$igu_file=$gps_week."/igu".$gps_week.$gps_day."_".$hour0.".sp3.Z";
                   }
print (F10 "C ",$time,$igu_file);
`wget ftp://cddis.gsfc.nasa.gov/pub/gps/products/$igu_file `;


if ($d[3] > 188000) {
$igu_file = $gps_week."/igr".$gps_week.$gps_day.".sp3.Z";
                   } else {
$igu_file=$gps_week."/igu".$gps_week.$gps_day."_".$hour0.".sp3.Z";

                   }


$igu_file="igu".$gps_week.$gps_day."_".$hour0.".sp3.Z";
################## Cambio temporal
`zcat $igu_file | ../prefits_bin/sp32txt.pl | ../prefits_bin/add_brdc_clock_2_igu.pl $d[$#d] $d[2] > orbit_gnss.dat.tmp`;
`../prefits_bin/merge_orbits_files.pl $d[2] $d[3] > orbit_gnss.dat_`;
`mv orbit_gnss.dat_ orbit_gnss.dat`;
#                    }
###################

$aa = `head  orbit_gnss.dat`;
print (F10 $time,$aa);
print (F10 $time,$igu_file);
`../prefits_bin/detect_eclipse`;
open(F2,"|../prefits_bin/del_eclipse_data.pl|../prefits_bin/model|");
##open(F2,"|../prefits_bin/model |");
                                                     }



####
####
if ($time <= 172800 && $d[6]!=-13 && $d[6]!=-4) {
print (F2 @d);

                      }

           }
